// ClockAppView.cpp : implementation of the CClockAppView class
//

#include "stdafx.h"
#include "ClockApp.h"

#include "ClockAppDoc.h"
#include "ClockAppView.h"

#include "ShowClock.h"
#include "GlobalConst.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CClockAppView

IMPLEMENT_DYNCREATE(CClockAppView, CView)

BEGIN_MESSAGE_MAP(CClockAppView, CView)
	//{{AFX_MSG_MAP(CClockAppView)
	ON_WM_SIZE()
	ON_WM_LBUTTONDBLCLK()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClockAppView construction/destruction

CClockAppView::CClockAppView()
: m_pClockShow (NULL)
{
	m_cstrValue1 = "Value_1 *** ";
	m_cstrValue2 = "Value_2 *** ";

	m_cstrValueCol = "green";

	((CClockAppApp*)AfxGetApp())->SetOurView(this);    
}

CClockAppView::~CClockAppView()
{
	// stoppen Uhr - Dialog
	ClockStop();
}

BOOL CClockAppView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CClockAppView drawing

void CClockAppView::OnDraw(CDC* pDC)
{
	CClockAppDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDC->TextOut(20,20, m_cstrValue1); 

	pDC->TextOut(20,50, m_cstrValue2); 

	pDC->TextOut(20,100, m_cstrValueCol);
}

/////////////////////////////////////////////////////////////////////////////
// CClockAppView printing

BOOL CClockAppView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CClockAppView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CClockAppView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CClockAppView diagnostics

#ifdef _DEBUG
void CClockAppView::AssertValid() const
{
	CView::AssertValid();
}

void CClockAppView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CClockAppDoc* CClockAppView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CClockAppDoc)));
	return (CClockAppDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CClockAppView message handlers


void CClockAppView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	moveDlg();
	
}

bool CClockAppView::moveDlg()
{
	if (m_pClockShow == NULL || this == NULL)
		return FALSE;

	if (m_pClockShow)
	{
		if (m_pClockShow->m_hWnd == NULL)
			return FALSE;
	}
	if (this)
	{
		if (this->m_hWnd == NULL)
			return FALSE;
	}

	try
	{
		if (NULL == m_pClockShow)
			return FALSE;

		CRect rect1, rect2;
		int nWidth1, nHight1, nWidth2, nHight2;

		// view
		this->GetWindowRect(&rect1); 
		nWidth1 = rect1.Width();
		nHight1 = rect1.Height();


		// the ClockShow dialog
		m_pClockShow->GetWindowRect(&rect2); 
		nWidth2 = rect2.Width();
		nHight2 = rect2.Height();

		// resize dialog
		int nTBp = 0, nFS_Xp = 0, nFS_Yp = 0;
		nTBp = GetSystemMetrics(SM_CYCAPTION); 
		nFS_Xp = GetSystemMetrics(SM_CXFRAME);
		nFS_Yp = GetSystemMetrics(SM_CYFRAME);

		m_pClockShow->MoveWindow(rect1.right - m_nClockWidth - 
								 nFS_Xp - nFS_Yp, rect1.top, m_nClockWidth + nFS_Xp + 
								 nFS_Yp, m_nClockHight + nTBp + nFS_Xp + nFS_Yp, TRUE);    
 
		return TRUE;
	}
	catch(...)
	{
		return FALSE;
	}
}

void CClockAppView::OnChangeColourOfClock(const int nCase, const int nTimerState)
{
	if (nTimerState == c_nStartTimer)
	{
		m_cstrValue1 = "Value_1 *** ";
		m_cstrValue2 = "Value_2 *** ";
	}

	m_cstrValueCol += " *** ";

	if (nCase == c_nRed)
		m_cstrValueCol += "red";
	else if (nCase == c_nGreen)
		m_cstrValueCol += "green";
	else if (nCase == c_nBlue)
		m_cstrValueCol += "blue";
	else if (nCase == c_nBlack)
		m_cstrValueCol += "black";
	else if (nCase == c_nLila)
		m_cstrValueCol += "lila";

	if (m_pClockShow)
	{
		m_pClockShow->OnChangeCol(nTimerState, nCase); 
	}
	else
	{
		// starten Uhr - Dialog
		ClockStart();	
	} 

	Invalidate(0); 
//	::PostMessage (m_pClockShow->m_hWnd, WM_NCPAINT, (WPARAM)1, (LPARAM)0);
}



void CClockAppView::ClockStart()
{
	try
	{
		if (m_pClockShow == NULL)
		{
			m_pClockShow = new ShowClock;

			if (m_pClockShow)
				m_pClockShow->Create(); 
		}

		moveDlg();

		m_pClockShow->startClockTimer(); 
	}
	catch(...)
	{
		TRACE0 ("CClockAppView::ClockStart - m_pClockShow = NULL...\n");
	}
}


void CClockAppView::ClockStop()
{
	if (m_pClockShow)
	{
		m_pClockShow->stopClockTimer();

		m_pClockShow->DestroyWindow();
		delete m_pClockShow;
		m_pClockShow = NULL;

		m_cstrValue1 = "Value_1 *** ";
		m_cstrValue2 = "Value_2 *** ";

//		Invalidate(); 
	}
}

void CClockAppView::ShowClockDlg(const BOOL bIsAppActive)
{
	if (m_pClockShow)
	{
		if (FALSE == bIsAppActive)
			m_pClockShow->ShowWindow(SW_HIDE); 
		else
			m_pClockShow->ShowWindow(SW_SHOW); 
	}
}


void CClockAppView::PrepareForDestroy()
{
	if (m_pClockShow)
	{
		m_pClockShow->PrepareForDestroy(); 
	}
}



void CClockAppView::SetInfo1(int nVal)
{
	CString cstrVal;
	cstrVal.Format("%d", nVal); 
	m_cstrValue1 += " - " + cstrVal;

	Invalidate(0); 
}


void CClockAppView::SetInfo2(int nVal)
{
	CClientDC dc(this);

	CString cstrVal;
	cstrVal.Format("%d", nVal); 
	m_cstrValue2 += " - " + cstrVal;

	Invalidate(0); 
}




void CClockAppView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	

}

void CClockAppView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	ClockStart();
	
	CView::OnLButtonDblClk(nFlags, point);
}
