// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "ClockApp.h"

#include "MainFrm.h"
#include "GlobalConst.h"
#include "ClockAppDoc.h"
#include "ClockAppView.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_MOVE()	
	ON_REGISTERED_MESSAGE (WM_CHANGECOLOUROFCLOCK, OnChangeColourOfClock)	
	ON_REGISTERED_MESSAGE (WM_SEND_INFO1, OnChangeInfo1)	
	ON_REGISTERED_MESSAGE (WM_SEND_INFO2, OnChangeInfo2)	
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
: m_pOurView (NULL)
{
	((CClockAppApp*)AfxGetApp())->SetOurMainFrame(this);
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}




BOOL CMainFrame::DestroyWindow() 
{
	// stop our timer in the clock_show - dialog
	if (m_pOurView)
	{
		m_pOurView->PrepareForDestroy(); 
	}

	// benachrichtigen unsere MasterApp
	::PostMessage(HWND_BROADCAST, WM_SHUTDOWN_APP, (WPARAM)0, (LPARAM)0); 

	return CFrameWnd::DestroyWindow();
}

void CMainFrame::SetOurView(CClockAppView* pView)
{
	m_pOurView = pView;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers



LRESULT CMainFrame::OnChangeColourOfClock(WPARAM wParam , LPARAM lParam)
{

	char myMsg[256];
	int nMsg = 0, nCase = 0;
	BOOL bIsWndActive = FALSE;

	// lesen alle Parameter

	sprintf(myMsg, "%d", wParam);	// msg - colour
	nMsg = atoi(myMsg);
	sprintf(myMsg, "%d", lParam);	// case - TimerState
	nCase = atoi(myMsg);

	// prfen, ob die Applikation sichtbar / unsichtbar ist
	bIsWndActive = checkIsAppActive();

	if (m_pOurView)
	{
		// schicken diese Message weiter an die View - Klasse
		m_pOurView->OnChangeColourOfClock(nMsg, nCase); 

		// machen Uhr - Dialog entsprechend sichtbar / unsichtbar
		m_pOurView->ShowClockDlg(bIsWndActive);

		return 1;
	}
	else
	{
		return 0;
	}
}


void CMainFrame::OnSize(UINT nType, int cx, int cy) 
{
	CFrameWnd::OnSize(nType, cx, cy);
	
	CRect rect1, rect2, rect3, rect4;
	int nWidth1, nHight1, nWidth2, nHight2;

	if (m_pOurView)
	{
		// view
//		pView->GetWindowRect(&rect1); 
		m_pOurView->GetClientRect(&rect1); 
		nWidth1 = rect1.Width();
		nHight1 = rect1.Height();

		// the main frame
//		this->GetWindowRect(&rect2);
		this->GetClientRect(&rect2);
		nWidth2 = rect2.Width();
		nHight2 = rect2.Height();
		
//		if (nWidth1 < nWidth2 && nHight1 < nHight2){return;}

		int nResizeWidth = 100, m_nResizeHight = 100;
		int nTBp = 0, nFS_Xp = 0, nFS_Yp = 0, nMS_Yp = 0;

		// width of the title bar
		nTBp = GetSystemMetrics(SM_CYCAPTION); 
		// Thickness, in pixels, of the sizing border around the perimeter of a window 
		// that can be resized. 
		nFS_Xp = GetSystemMetrics(SM_CXFRAME);	
		nFS_Yp = GetSystemMetrics(SM_CYFRAME);
		// width of the menu bar
		nMS_Yp = GetSystemMetrics(SM_CYMENUSIZE);

		// resize the view
//		pView->SetWindowPos(&wndNoTopMost, rect1.left, rect1.top, 
							nWidth2,nHight2, 
//		pView->SetWindowPos(NULL, 0, 0, nWidth2,nHight2, 
//			SWP_DEFERERASE | SWP_DRAWFRAME | 
//	SWP_FRAMECHANGED | SWP_NOZORDER | SWP_NOMOVE); //

//		m_pOurView->MoveWindow(rect1.left, rect1.top, nWidth2 - 2 * nFS_Yp, 
//			 nHight2 - nTBp - nMS_Yp - 2 * nFS_Xp, TRUE); 


		m_pOurView->MoveWindow(rect1.left, rect1.top, nWidth2, 
			 nHight2 - nMS_Yp, TRUE); 


		// prfen, ob die Applikation sichtbar / unsichtbar ist
		BOOL bIsWndActive = checkIsAppActive();

		// machen Uhr - Dialog entsprechend sichtbar / unsichtbar
		m_pOurView->ShowClockDlg(bIsWndActive);
	}			

}


void CMainFrame::OnMove(int x, int y) 
{
	CFrameWnd::OnMove(x, y);
	
	if (m_pOurView)
	{
		// move clock - dialog
		m_pOurView->moveDlg(); 
	}
	
}

BOOL CMainFrame::checkIsAppActive()
{
	if(this->IsIconic())
	{
		return FALSE;
	} 
	else
	{
		return TRUE;
	}
}


LRESULT CMainFrame::OnChangeInfo1(WPARAM wParam , LPARAM lParam)
{
	int nValue = 0;

	// lesen alle Parameter
	nValue = (int)(wParam);

	if (m_pOurView)
	{
		m_pOurView->SetInfo1(nValue);
	}

	return 0;
}


LRESULT CMainFrame::OnChangeInfo2(WPARAM wParam , LPARAM lParam)
{	
	int nValue = 0;

	// lesen alle Parameter
	nValue = (int)(wParam);

	if (m_pOurView)
	{
		m_pOurView->SetInfo2(nValue);
	}

	return 0;
}
