// ShowClock.cpp : implementation file
//

#include "stdafx.h"
#include "ClockApp.h"

#include "ClockAppDoc.h"
#include "ClockAppView.h"
#include "ShowClock.h"

// **************************
#include "GlobalConst.h"

#include <math.h>


// **************************

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// ShowClock dialog


ShowClock::ShowClock(CWnd* pParent /*=NULL*/)
	: CDialog(ShowClock::IDD, pParent)
{
	//{{AFX_DATA_INIT(ShowClock)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_nX1 = 0;
	m_nX2 = m_nClockWidth;
	m_nY1 = 0;
	m_nY2 = m_nClockHight;

	m_dMinute = 0.0f;
	m_nTimerRange = c_nTimerRefresh;
	m_nPart = c_nClockStep;

	m_nRed = 0;
	m_nGreen = 0; 
	m_nBlue = 0;

	m_nRed_bc = 0;
	m_nGreen_bc = 0; 
	m_nBlue_bc = 0;

	m_bClockMustBeDel = FALSE;
	m_bClockStarted = FALSE;

	m_nCase = c_nGreen;

//	m_nTimerEventId = 0;
}

ShowClock::~ShowClock()
{
//	stopClockTimer();
}


void ShowClock::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ShowClock)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(ShowClock, CDialog)
	//{{AFX_MSG_MAP(ShowClock)
	ON_WM_TIMER()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ShowClock message handlers

BOOL ShowClock::Create() 
{
	CRect rect;
	BOOL bCreated = CDialog::Create(ShowClock::IDD);
	ShowWindow(SW_SHOW);	
	
	startClockTimer();

	return bCreated;
}

void ShowClock::OnTimer(UINT nIDEvent) 
{
	COleDateTime tmpDT = COleDateTime::GetCurrentTime();
	int nHour = tmpDT.GetHour(); 
	int nMin = tmpDT.GetMinute(); 
	int nSec = tmpDT.GetSecond(); 

	CString strDT, strMin;
	strDT.Format("::OnTimer *** %d:%d:%d  *** ", nHour, nMin, nSec) ;

	TRACE (strDT);

	// clock timer
	if (nIDEvent == ID_VALACT_TIMER)
	{
		// berechnen aktuellen Wert von der Minuten - Anzeige
		m_dMinute += (int) (60 / m_nPart);

		strMin.Format("  Min = %f \n", m_dMinute); 
		TRACE (strMin);
		if (m_dMinute > 60)
			m_dMinute = 0;
	}

	Invalidate(0);

	CDialog::OnTimer(nIDEvent);
}

void ShowClock::OnPaint() 
{
	try
	{
		int x1 = 0, x2 = 0, x0 = 0, y1 = 0, y2 = 0, y0 = 0, r = 0;
		double angle = 0.0f;
		CRect myRect, clientRect, clockRect;
		CPoint pStart, pEnd, pCurrent;
		CPaintDC dcReal(this);
		CDC dcClock;
		CBitmap bmpMem;

		// setzen den Rectangle
		myRect.left = m_nX1;
		myRect.top = m_nY1;
		myRect.bottom = m_nY2;
		myRect.right = m_nX2;

		// holen uns den client Rectangle
		GetClientRect(&clientRect); 

		// prfen, ob under Rectangle nicht grsser ist, als client Rectangle
		if (myRect.left < clientRect.left)
			myRect.left = clientRect.left;
		if (myRect.top < clientRect.top)
			myRect.top = clientRect.top;
		if (myRect.bottom > clientRect.bottom)
			myRect.bottom = clientRect.bottom;
		if (myRect.right > clientRect.right)
			myRect.right = clientRect.right;

		// setzen den Rectangle fr den Bitmap
		clockRect.left = 0;
		clockRect.top = 0;
		clockRect.bottom = myRect.Height();
		clockRect.right = myRect.Width();

		// erzeugen den Bitmap, um im Speicher malen zu knnen
		dcClock.CreateCompatibleDC(&dcReal);
		bmpMem.CreateCompatibleBitmap(&dcReal,myRect.Width(),myRect.Height());
		CBitmap *oldbmpMem=dcClock.SelectObject(&bmpMem);

		// setzen die richtige Hintergrundfarbe fr den Bitmap
		CBrush br;
		br.CreateSysColorBrush(COLOR_BTNFACE);
		CBrush  *oldBrush=dcClock.SelectObject(&br);
		dcClock.PatBlt(clockRect.left, clockRect.top, clockRect.Width(), clockRect.Height(), PATCOPY);
		
		if (m_bClockMustBeDel == false)
		{
			// malen die Uhr im Speicher
			PaintClock(dcClock, m_dMinute, clockRect);
		}
		else
		{
			m_bClockMustBeDel = false;
		}

		// kopieren das aus dem Speicher auf das Bildschirm
		dcReal.BitBlt(myRect.left, myRect.top, myRect.Width(), myRect.Height(),	&dcClock, 0, 0, SRCCOPY);
		dcClock.SelectObject(oldbmpMem);
		bmpMem.DeleteObject();
		
		// entfernen alle temporre Objekte
		dcClock.SelectObject(oldBrush);
		br.DeleteObject();
		ReleaseDC(&dcClock);
	}
	catch (...)
	{

	}
	// Do not call CDialog::OnPaint() for painting messages
}



BOOL ShowClock::OnChangeCol(const int nTimerState , const int nCase)
{
	// wenn es unsere Message ist, 
	if (nTimerState == c_nChangeColour)
	{
		// wenn es um die Farbennderung geht
		m_nCase = nCase;
	}
	else if (nTimerState == c_nStartTimer)
	{
		// wenn es um den neuen Start vom Timer geht
		stopClockTimer();
		startClockTimer(); 
	}
	else if (nTimerState == n_cStopTimer)
	{
		// wenn es um den neuen Start vom Timer geht
		stopClockTimer();
	}

	setAllColours();
	Invalidate(0);

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// ShowClock help functions

BOOL ShowClock::startClockTimer()
{
	TRACE ("startClockTimer --->  \n");

	try
	{
		UINT		nTimerIn = 0;
		
		m_nCase = c_nGreen;

		setAllColours();
		setRect();

//		nTimerIn = SetTimer(ID_VALACT_TIMER, m_nTimerRange / m_nPart, MyTimerProc);
		nTimerIn = SetTimer(ID_VALACT_TIMER, m_nTimerRange / m_nPart, NULL);

/*
		// multimedia timer
		// =================

		TIMECAPS tc;	

		if (timeGetDevCaps(&tc, sizeof(TIMECAPS)) != TIMERR_NOERROR) 	
		{		
			TRACE ("timeGetDevCaps geht nicht ...");
		}
		else
		{
			if (m_nTimerEventId == 0)
			{
				nTimerPeriod = min(max(tc.wPeriodMin, TARGET_RESOLUTION), tc.wPeriodMax);	
				timeBeginPeriod(nTimerPeriod);	
				ShowClock* pWndClock = this;
				m_nTimerEventId = timeSetEvent(m_nTimerRange / (m_nPart - 1), nTimerPeriod, MultimediaTimerProc, (DWORD)pWndClock, TIME_PERIODIC);

				hWnd = this->GetSafeHwnd();
			}
		}
*/
		m_dMinute = 0;
	
		Invalidate(0);

		return TRUE;
	}
	catch(...)
	{
		return FALSE;
	}
}


BOOL ShowClock::stopClockTimer()
{
	try
	{
		if (this && this->m_hWnd)
		{
			KillTimer(ID_VALACT_TIMER);

//			timeEndPeriod(nTimerPeriod);	
//			timeKillEvent(m_nTimerEventId);
		}

		m_bClockStarted = FALSE;
		return TRUE;
	}
	catch(...)
	{
		return FALSE;
	}
}

BOOL ShowClock::setAllColours()
{
	try
	{
		// set background color (gray)
		setColour(0, c_nBCGray_red, c_nBCGray_green, c_nBCGray_blue);

		// set main (foreground) color (red or green)
		if (m_nCase == c_nRed)
			setColour(1, c_nFCRed_red, c_nFCRed_green, c_nFCRed_blue);
		else if (m_nCase == c_nGreen)
			setColour(1, c_nFCGreen_red, c_nFCGreen_green, c_nFCGreen_blue);
		else if (m_nCase == c_nBlue)
			setColour(1, 0, 0, 255);
		else if (m_nCase == c_nBlack)
			setColour(1, 0, 0, 0);
		else if (m_nCase == c_nLila)
			setColour(1, 190, 10, 10);

		return TRUE;
	}
	catch(...)
	{
		return FALSE;
	}
}

// nCase = 0 : back colours
// nCase = 1 : front colours
BOOL ShowClock::setColour(const short nCase, const int nRed, 
						  const int nGreen, const int nBlue)
{
	try
	{
		if (nCase == 0)
			setRGB_bc(nRed, nGreen, nBlue);
		else if (nCase == 1)
			setRGB(nRed, nGreen, nBlue);
		return TRUE;
	}
	catch(...)
	{
		return FALSE;
	}
}


BOOL ShowClock::setRect(const int x1, const int x2, const int y1, const int y2)
{
	try
	{
		m_nX1 = x1;
		m_nX2 = x2;
		m_nY1 = y1;
		m_nY2 = y2;

		m_myRect.top = m_nY1;
		m_myRect.left = m_nX1;
		m_myRect.right = m_nX1;
		m_myRect.bottom = m_nY2;
		return TRUE;
	}
	catch(...)
	{
		return FALSE;
	}
}


BOOL ShowClock::setRect()
{
	try
	{
		CString sx1, sx2, sy1, sy2;
		int  nx1, nx2, ny1, ny2;

		nx1 = 0;
		nx2 = 50;
		ny1 = 0;
		ny2 = 50;
		setRect(nx1, nx2, ny1, ny2); 

		return TRUE;
	}
	catch(...)
	{
		return FALSE;
	}
}


void ShowClock::setRGB(const BYTE nRed, const BYTE nGreen, const BYTE nBlue)
{
	m_nRed = nRed;
	m_nGreen = nGreen;
	m_nBlue = nBlue;
}


void ShowClock::setRGB_bc(const BYTE nRed, const BYTE nGreen, const BYTE nBlue)
{
	m_nRed_bc = nRed;
	m_nGreen_bc = nGreen;
	m_nBlue_bc = nBlue;
}


BOOL ShowClock::PaintClock(CDC &dc, const double nMinute_in, CRect& myRect)
{
	try
	{
		int x1 = 0, x2 = 0, x0 = 0, y1 = 0, y2 = 0, y0 = 0, r = 0;
		double angle = 0.0f;
		CPoint pStart, pEnd, pCurrent;
		CRgn rgn;

		CBrush curBrushRect(RGB(m_nRed, m_nGreen, m_nBlue));
		CBrush curBrush(RGB(m_nRed_bc, m_nGreen_bc, m_nBlue_bc));
		CBrush* pOldBrush = dc.SelectObject(&curBrushRect);

		// berechnen die Mitte und den Radius
		r = (myRect.right - myRect.left) / 2;
		x0 = myRect.left + r;
		y0 = myRect.top + r;
		// zuerst malen das Bereich
		rgn.CreateEllipticRgn(myRect.left, myRect.top, myRect.right, myRect.bottom);	//WINDING
		dc.FillRgn(&rgn, &curBrushRect); 
		rgn.DeleteObject(); 
		// malen den Kreis
		dc.Ellipse(&myRect);
		
		// gehen zum Zentrum
		dc.MoveTo(x0, y0); 
		dc.LineTo(x0, myRect.top); 
		dc.SelectObject(&curBrush);

		// berechnen den Winkel
		angle = (nMinute_in - 15) * PI / 30;
		// berechen den neuen Punkt auf dem Kreis
		pStart.x = x0;
		pStart.y = myRect.top; 
		pEnd.x = x0 + (int) (r * cos(angle) + 0.5);
		pEnd.y = y0 + (int) (r * sin(angle) + 0.5);
		// prfen den Unterschied zwischen zwei Punkten
		if ( (abs(pEnd.x - pStart.x) < m_cDelta) && (abs(pEnd.y - pStart.y) < m_cDelta) )
		{
			// wenn zu klein - einfach eine Linie malen
			dc.MoveTo(x0, y0);
			dc.LineTo(pStart); 
		}
		else
		{
			// wenn OK - dann Sektor malen und die Farbe dort ndern
			dc.SetArcDirection(AD_CLOCKWISE); 
			dc.Pie(&myRect,pStart, pEnd);  
			dc.SelectObject(&pOldBrush);
		}
		dc.SelectObject(pOldBrush);

		return TRUE;
	}
	catch (...)
	{
		return FALSE;
	}
}


void ShowClock::PrepareForDestroy()
{
	// vor dem Destroy() - Aufruf muss zuerst der Timer gestoppt werden
	stopClockTimer();
}

/*

void CALLBACK EXPORT MyTimerProc(
							   HWND hWnd,      // handle of CWnd that called SetTimer
							   UINT nMsg,      // WM_TIMER
							   UINT nIDEvent,   // timer identification
							   DWORD dwTime    // system time
								)
{
	COleDateTime tmpDT = COleDateTime::GetCurrentTime();
	int nHour = tmpDT.GetHour(); 
	int nMin = tmpDT.GetMinute(); 
	int nSec = tmpDT.GetSecond(); 

	CString strDT, strMin;
	strDT.Format("MyTimerProc *** %d:%d:%d  *** ", nHour, nMin, nSec) ;

	TRACE (strDT);

	// clock timer
	if (nIDEvent == ID_VALACT_TIMER)
	{
		// berechnen aktuellen Wert von der Minuten - Anzeige
		m_dMinute += (int) (60 / m_nPart);

		strMin.Format("  Min = %f \n", m_dMinute); 
		TRACE (strMin);
		if (m_dMinute > 60)
			m_dMinute = 0;
	}

//	::PostMessage(hWnd, WM_NCPAINT, (WPARAM)0, (LPARAM)0);
}


*/

/*

void CALLBACK MultimediaTimerProc(UINT uTimerID, UINT uMsg,	DWORD dwUser, DWORD dw1, 
								  DWORD dw2)
{     
	COleDateTime tmpDT = COleDateTime::GetCurrentTime();
	int nHour = tmpDT.GetHour(); 
	int nMin = tmpDT.GetMinute(); 
	int nSec = tmpDT.GetSecond(); 

	CString strDT, strMin;
	strDT.Format("MultimediaTimerProc *** %d:%d:%d  *** \n", nHour, nMin, nSec) ;

	TRACE (strDT);

	{
		// berechnen aktuellen Wert von der Minuten - Anzeige
		m_dMinute += (int) (60 / m_nPart);

		strMin.Format("  Min = %f \n", m_dMinute); 
		TRACE (strMin);
		if (m_dMinute >= 60)
			m_dMinute = 0;
	}

	ShowClock* pWndClock = (ShowClock*)dwUser;
	if (pWndClock)
	{
//		pWndClock->RedrawWindow(NULL, NULL, RDW_UPDATENOW | RDW_NOINTERNALPAINT);   
		pWndClock->OnPaint(); 
	}
}
*/


