// ManageOtherApp.cpp : implementation file
//

#include "stdafx.h"
#include "MasterApp.h"
#include "ManageOtherApp.h"

#include "SendInfoInThread.h"
#include <math.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CManageOtherApp dialog


CManageOtherApp::CManageOtherApp(CWnd* pParent /*=NULL*/)
	: CDialog(CManageOtherApp::IDD, pParent)
{
	//{{AFX_DATA_INIT(CManageOtherApp)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

	m_cstrColours.InsertAt(0, CString("dark-green"));
	m_cstrColours.InsertAt(1, CString("green"));
	m_cstrColours.InsertAt(2, CString("blue"));
	m_cstrColours.InsertAt(3, CString("black"));
	m_cstrColours.InsertAt(4, CString("lila"));

	m_pSendInfo = NULL;

	m_nLoopCounter2 = 160000;
	m_nDev2 = 160;

	m_nLoopCounter1 = 10000;
	m_nDev1 = 50;

	m_bIsAppActive = FALSE;
}

CManageOtherApp::~CManageOtherApp()
{
    if (m_pSendInfo)
    {
        delete m_pSendInfo;
        m_pSendInfo = NULL;
    }
}

void CManageOtherApp::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CManageOtherApp)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CManageOtherApp, CDialog)
	//{{AFX_MSG_MAP(CManageOtherApp)
	ON_BN_CLICKED(IDC_CHANGE_COL, OnChangeCol)
	ON_BN_CLICKED(IDC_START_CLOCKAPP, OnStartClockapp)
	ON_BN_CLICKED(IDC_STOP_CLOCKAPP, OnStopClockapp)
	ON_WM_TIMER()

	ON_MESSAGE( WM_SEND_INFO_1, OnSendInfo1 )

	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CManageOtherApp message handlers


BOOL CManageOtherApp::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CComboBox* pCmb = (CComboBox*) GetDlgItem(IDC_COLOURS); 
	if (pCmb)
	{
		for (int i = 0; i < 5; i++)
		{
			pCmb->InsertString(i, m_cstrColours.GetAt(i));  
		}

		pCmb->SetCurSel(0); 
	}
	
	SetValInEditBox(IDC_LOOP1, m_nLoopCounter1);
	SetValInEditBox(IDC_LOOP2, m_nLoopCounter2);

	SetValInEditBox(IDC_QUOT1, m_nDev1);
	SetValInEditBox(IDC_QUOT2, m_nDev2);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CManageOtherApp::OnChangeCol() 
{
	CComboBox* pCmb = (CComboBox*) GetDlgItem(IDC_COLOURS); 
	if (pCmb)
	{
		int nSel = pCmb->GetCurSel(); 

		ChangeColourOfClock(nSel);
	}	
}

void CManageOtherApp::OnStartClockapp() 
{
	UINT nTimer = 0;

	GetValInEditBox(IDC_LOOP1);
	GetValInEditBox(IDC_LOOP2);
	GetValInEditBox(IDC_QUOT1);
	GetValInEditBox(IDC_QUOT2);

	if (FALSE == m_bIsAppActive)
	{
		HWND hwnd ;
		hwnd = ::GetDesktopWindow();
		ShellExecute(hwnd, "Open", "ClockApp.exe", "", "D:\\irina\\d_prog_2\\Exercises\\controls\\clock_two_app\\ClockApp\\Debug", SW_SHOWNORMAL);

		m_bIsAppActive = TRUE;
	}

    // zyklisches Auslesen des GA-Meldepuffers zur Aktualisierung
    nTimer = SetTimer(ID_ANLVISU_TIMER, c_nTimerRefresh, NULL);	

	// starten eine Hilfsfunktion, andere wird beim Timerstart gestartet
	if (m_pSendInfo == NULL)
	{
		m_pSendInfo = new CSendInfoInThread (StartSendInfos, c_nTimerRefresh, this->GetSafeHwnd());
	}

	// starten Aktualisierungsuhr
	ChangeColourOfClock (c_nGreen, c_nStartTimer); 

	StartSendInfos2();

}

void CManageOtherApp::OnStopClockapp() 
{
	// starten Aktualisierungsuhr
	ChangeColourOfClock (c_nGreen, n_cStopTimer); 

        KillTimer(ID_ANLVISU_TIMER);

        if (m_pSendInfo)
        {
            delete m_pSendInfo;
            m_pSendInfo = NULL;
        }
}




////////////////

void CManageOtherApp::StartSendInfos1()
{
	// ClockApp benachrichtigen, dass die Aktualisierung gestartet wurde
	ChangeColourOfClock(c_nRed);

	// ab und zu senden Info-Message an ClockApp
	for (int i = 0; i < m_nLoopCounter1; i++)
	{
		div_t div_result;
		div_result = div( i, m_nDev1 );

		if (div_result.rem == 0)
		{
			SendInfo(WM_SEND_INFO1, i);

			writeInTestBox(i, 1);
		}
	}

	// ClockApp benachrichtigen, dass die Aktualisierung beendet wurde
	ChangeColourOfClock(c_nGreen);
}



void CManageOtherApp::StartSendInfos2()
{
	// ClockApp benachrichtigen, dass die Aktualisierung gestartet wurde
	ChangeColourOfClock(c_nRed);

	// ab und zu senden Info-Message an ClockApp
	for (int i = 0; i < m_nLoopCounter2; i++)
	{
		div_t div_result;
		div_result = div( i, m_nDev2 );

		if (div_result.rem == 0)
		{
			SendInfo(WM_SEND_INFO2, i);

			writeInTestBox(i, 2);
		}
	}

	// ClockApp benachrichtigen, dass die Aktualisierung beendet wurde
	ChangeColourOfClock(c_nGreen);
}


void CManageOtherApp::SendInfo(const UINT nMsg, const int nVal)
{
	::PostMessage(HWND_BROADCAST, nMsg, (WPARAM)nVal, (LPARAM)0); 
}




///////////////////////////////////////////////////////////////////////////////
//
//  Method / Function        :	ChangeColourOfClock
//  Author                   :	
//  Date                     :	
//
//-----------------------------------------------------------------------------
//
//  Preconditions            :
//
//  Description              :	sobald die Aktualisierung gestartet oder beendet wird,
//								muss man die ssshow - Applikation darber benachrichtigen,
//								damit die Aktualisierungsuhr entsprechende Farbe kriegen knnte
//
//  Input                    :	entsprechende Farbe fr die Aktualisierungsuhr
//
//  Output                   :	
//
///////////////////////////////////////////////////////////////////////////////
void CManageOtherApp::ChangeColourOfClock(const UINT nColour, const UINT nTimerState)
{

	if (nTimerState == c_nStartTimer)
	{
		COleDateTime tmpDT = COleDateTime::GetCurrentTime();
		int nHour = tmpDT.GetHour(); 
		int nMin = tmpDT.GetMinute(); 
		int nSec = tmpDT.GetSecond(); 

		CString strDT, strMin;
		strDT.Format("::OnTimer *** %d:%d:%d  *** \n", nHour, nMin, nSec) ;

		TRACE (strDT);
	}

	::PostMessage(HWND_BROADCAST, WM_CHANGECOLOUROFCLOCK, 
				  (WPARAM)nColour, (LPARAM)nTimerState); 
}



void CManageOtherApp::OnTimer(UINT nIDEvent) 
{
    if (nIDEvent == ID_ANLVISU_TIMER)
    {
		// ClockApp benachrichtigen, dass der neue Refresh - Zyklus angefangen wurde
		ChangeColourOfClock (c_nGreen, c_nStartTimer); 

        StartSendInfos2();
    }
	
	CDialog::OnTimer(nIDEvent);
}


LRESULT CManageOtherApp::OnSendInfo1(WPARAM wParam, LPARAM lParam)
{
    StartSendInfos1();
	return 0;
}



void CManageOtherApp::ClockAppIsDown()
{
	try
	{
		if (this->m_hWnd)
		{
			KillTimer(ID_ANLVISU_TIMER);
		}

        if (m_pSendInfo)
        {
            delete m_pSendInfo;
            m_pSendInfo = NULL;
        }
	}
	catch (...)
	{
	}
}


void CManageOtherApp::writeInTestBox(int nVal, int nCase)
{
	CEdit* pEdit = (CEdit*) GetDlgItem(IDC_RES_TEST); 

	CString cstrMsg, cstrVal, cstrAll;
	char sTmp[100000];
	if (pEdit)
	{
		if (1 == nCase)
		{
			cstrMsg = "Value 1 *** ";
		}
		else
		{
			cstrMsg = "Value 2 *** ";
		}

		cstrVal.Format("%d", nVal); 

		cstrMsg += cstrVal;

		pEdit->GetWindowText(cstrAll);

		cstrAll += "\r\n";
		cstrAll += cstrMsg;
		strcpy(sTmp, cstrAll);

//		pEdit->SetWindowText(sTmp); 
	}
}


void CManageOtherApp::SetValInEditBox(UINT nId, const int nVal)
{
	CEdit* pEdit = (CEdit*)GetDlgItem(nId);
	if (pEdit)
	{
		char cstrVal[128];
		sprintf(cstrVal, "%d", nVal);
		
		pEdit->SetWindowText(cstrVal); 
	}
}

void CManageOtherApp::GetValInEditBox(UINT nId)
{
	CEdit* pEdit = (CEdit*)GetDlgItem(nId);
	if (pEdit)
	{
		CString cstrVal;
		pEdit->GetWindowText(cstrVal); 

		int nVal = atoi(cstrVal);

		switch (nId)
		{
			case IDC_LOOP1:
				m_nLoopCounter1 = nVal;
				break;

			case IDC_LOOP2:
				m_nLoopCounter2 = nVal;
				break;

			case IDC_QUOT1:
				m_nDev1 = nVal; 
				break;

			case IDC_QUOT2:
				m_nDev2 = nVal;
				break;
		}
	}
}
