// SendInfoInThread.cpp: implementation of the CSendInfoInThread class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MasterApp.h"
#include "SendInfoInThread.h"

#include "GlobalConst.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSendInfoInThread::CSendInfoInThread(void (*function)(), DWORD dwZyklus, HWND hWindow)
{
    m_hThread     = NULL;
    m_dwThreadID  = 0;
	dwPeriod      = dwZyklus;
	hWnd		  = hWindow;

    // Event zum Beenden des Threads erzeugen
	hEventStop = CreateEvent(NULL, TRUE, FALSE, NULL);

    // Thread der bergebenen Funktion erzeugen
    m_hThread = ::CreateThread(NULL,
                               0,
                               (LPTHREAD_START_ROUTINE)(*function),
                               NULL,
                               0,
                               &m_dwThreadID);

    if (m_hThread == NULL)
    {
		TRACE0 ("m_hThread == NULL ....");
    }          

}

CSendInfoInThread::~CSendInfoInThread()
{
    BOOL bRet = SetEvent(hEventStop);

	if(bRet == FALSE)
	{
        // dann eben auf die harte Tour...
        TerminateThread(m_hThread, 0);
    }

    CloseHandle(m_hThread);
    CloseHandle(hEventStop);
}


void StartSendInfos()
{
    while (::WaitForSingleObject(hEventStop, dwPeriod) == WAIT_TIMEOUT)
    {
		COleDateTime tmpDT = COleDateTime::GetCurrentTime();
		int nHour = tmpDT.GetHour(); 
		int nMin = tmpDT.GetMinute(); 
		int nSec = tmpDT.GetSecond(); 

		CString strDT;
		strDT.Format("::StartSendInfos *** %d:%d:%d  *** \n", nHour, nMin, nSec) ;

		TRACE (strDT);

        // ...dann Nachricht an das aufrufende Fenster
        ::PostMessage(hWnd, WM_SEND_INFO_1, 0, 0);
  }
}

